---
updatedAt: 2026-04-23T13:45:10.000Z
agentTools:
  projectIndex: https://docs.br-dge.io/llms.txt
---

# Create a payment

Request a transfer of funds between accounts at banks or other financial institutions.


# OpenAPI definition

```json
{
  "openapi": "3.0.3",
  "info": {
    "title": "BR-DGE Transaction REST API",
    "description": "Use the BR-DGE Transaction REST API to manage and process transactions within BR-DGE. With these endpoints, you can create, retrieve, update and delete transactions securely and efficiently. These unlock access to various third-party payment services such as Payment Service Providers (PSPs), Digital Wallets and Alternative Payment Methods (APMs).\n\nPlease see our [Web SDK documentation] for more information about how we can help you integrate your client applications with us.\n## Authorization\nAPI keys can be generated via the BR-DGE portal and are grouped into two main classes based on their usage:\n- Server API keys for use by you in your secure back-end services, *and must not be exposed to your end users.*\n- Separate Client API keys will be provided for use in client applications to support certain features that need to\n  happen in untrusted client environments.\n\n## Environment Sub Domains\nThe BR-DGE REST API is hosted on a selection of subdomains. Use <https://sandbox.comcarde.com> for testing and either <https://secure.comcarde.com> or <https://secure-amer-01.api.br-dge.io> for live payments depending on your operational region.\n\n**IMPORTANT**: To ensure [PCI Compliance], please only use mock payment instrument data when interacting with our Sandbox API.\n\n[PCI Compliance]: https://www.pcisecuritystandards.org/\n[Web SDK documentation]: https://docs.br-dge.io/docs/web-sdk-introduction\n",
    "version": "v1.0.0",
    "contact": {
      "name": "Customer Support",
      "url": "https://docs.br-dge.io/docs/support#contact-support"
    },
    "license": {
      "name": "MIT",
      "url": "https://docs.br-dge.io/docs/openapi-license"
    }
  },
  "servers": [
    {
      "url": "https://sandbox.comcarde.com/v1",
      "description": "Sandbox subdomain for testing your integration works as expected, using mock payment instruments only.\n"
    },
    {
      "url": "https://secure.comcarde.com/v1",
      "description": "Use this subdomain for processing live payments in the EU region."
    },
    {
      "url": "https://secure-amer-01.api.br-dge.io/v1",
      "description": "Use this subdomain for processing live payments in the NA region."
    }
  ],
  "tags": [
    {
      "name": "Payments",
      "description": "Collect money from all of your customers."
    }
  ],
  "externalDocs": {
    "url": "https://docs.br-dge.io"
  },
  "paths": {
    "/payments": {
      "post": {
        "tags": [
          "Payments"
        ],
        "summary": "Create a payment",
        "description": "Request a transfer of funds between accounts at banks or other financial institutions.\n",
        "operationId": "createPaymentUsingPOST",
        "security": [
          {
            "ServerApiKey": []
          }
        ],
        "parameters": [
          {
            "name": "expand",
            "in": "query",
            "description": "The presence of this field returns extra metadata,\nthat may or may not be attached to the payment.\nThe individual metadata that is returned is implementation dependant\nand different fields may be returned in different areas of the response.\n\nCurrently the only supported parameter is `expand=rawPspResponse`.\n\nParameter values:\n * `rawPspResponse` - Include the `rawPspResponses` array within the `pspInfo`\n   response field, if present within the payment.\n\n   Not all payment solutions are currently supported with rawPspResponse.\n\n   The data that is returned in this field is *NOT* internally controlled\n   and will be different depending on the Payment Solution Provider (PSP).\n\n   We make no guarantees about the information included within the rawPspResponse.\n\n   **See:** Response example `Successful payment with expanded rawPspResponse`\n",
            "schema": {
              "type": "array",
              "uniqueItems": true,
              "items": {
                "type": "string",
                "enum": [
                  "rawPspResponse"
                ]
              }
            }
          },
          {
            "name": "include",
            "in": "query",
            "description": "A parameter allowing the inclusion of related information.\n\nThis parameter follows closely the [JSON:API Inclusion of Related\nResources]. Specifying valid entries will result in the entities\nbeing included in the `included` section of the response.\n\n[JSON:API Inclusion of Related Resources]: https://jsonapi.org/format/1.1/#fetching-includes\n",
            "schema": {
              "type": "array",
              "items": {
                "type": "string",
                "enum": [
                  "paymentInstrument",
                  "issuerResponse"
                ]
              },
              "uniqueItems": true
            },
            "explode": false
          }
        ],
        "requestBody": {
          "required": true,
          "description": "Details of the payment to be initiated.",
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/PaymentRequest"
              },
              "examples": {
                "tokenized-payment": {
                  "$ref": "#/components/examples/payment-request-tokenized"
                },
                "card-payment": {
                  "$ref": "#/components/examples/payment-request-card"
                },
                "card-payment-create-card-on-file": {
                  "$ref": "#/components/examples/payment-request-card-create-card-on-file"
                },
                "paypal-payment": {
                  "$ref": "#/components/examples/payment-request-paypal"
                },
                "googlepay-payment": {
                  "$ref": "#/components/examples/payment-request-googlepay"
                },
                "applepay-payment": {
                  "$ref": "#/components/examples/payment-request-applepay"
                },
                "providerThreeDSecureNonce-payment": {
                  "$ref": "#/components/examples/payment-request-providerThreeDSecureNonce"
                },
                "split-auth-and-capture": {
                  "$ref": "#/components/examples/payment-request-split-auth-and-capture"
                },
                "ideal-payment": {
                  "$ref": "#/components/examples/payment-request-ideal"
                },
                "bancontact-payment": {
                  "$ref": "#/components/examples/payment-request-bancontact"
                },
                "trustly-payment": {
                  "$ref": "#/components/examples/payment-request-trustly"
                },
                "paysafecard-payment": {
                  "$ref": "#/components/examples/payment-request-paysafecard"
                },
                "pix-payment": {
                  "$ref": "#/components/examples/payment-request-pix"
                },
                "astropay-payment": {
                  "$ref": "#/components/examples/payment-request-astropay"
                },
                "neteller-payment": {
                  "$ref": "#/components/examples/payment-request-neteller"
                },
                "oneVoucher-payment": {
                  "$ref": "#/components/examples/payment-request-oneVoucher"
                },
                "ottVoucher-payment": {
                  "$ref": "#/components/examples/payment-request-ottVoucher"
                },
                "bluVoucher-payment": {
                  "$ref": "#/components/examples/payment-request-bluVoucher"
                },
                "revolutpay-payment": {
                  "$ref": "#/components/examples/payment-request-revolutpay"
                },
                "tokenized-payment-initial-mit": {
                  "$ref": "#/components/examples/payment-request-tokenized-initial-mit"
                },
                "tokenized-payment-subsequent-mit": {
                  "$ref": "#/components/examples/payment-request-tokenized-subsequent-mit"
                },
                "PspTokenInstrument": {
                  "$ref": "#/components/examples/payment-request-psp-token"
                },
                "riskInstruments": {
                  "$ref": "#/components/examples/payment-request-risk-instruments"
                },
                "externalThreeDS-payment": {
                  "$ref": "#/components/examples/payment-request-external-3ds"
                },
                "customMetadata-payment": {
                  "$ref": "#/components/examples/payment-request-custom-metadata"
                },
                "skrill-payment": {
                  "$ref": "#/components/examples/payment-request-skrill"
                },
                "skrill-one-tap-payment": {
                  "$ref": "#/components/examples/payment-request-skrill-one-tap"
                },
                "truelayer-payment": {
                  "$ref": "#/components/examples/payment-request-truelayer"
                },
                "truelayer-payment-with-bank-details": {
                  "$ref": "#/components/examples/payment-request-truelayer-using-bankDetails"
                },
                "bank2bank-payment": {
                  "$ref": "#/components/examples/payment-request-bank2bank"
                },
                "aft-payment": {
                  "$ref": "#/components/examples/payment-request-card-aft"
                }
              }
            }
          }
        },
        "responses": {
          "201": {
            "description": "Payment request completed successfully.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/PaymentResponse"
                },
                "examples": {
                  "Successful payment": {
                    "$ref": "#/components/examples/payment-response-successful"
                  },
                  "Successful payment with expanded rawPspResponse": {
                    "$ref": "#/components/examples/payment-response-successful-rawPspResponse"
                  },
                  "Successful payment with included paymentInstrument": {
                    "$ref": "#/components/examples/payment-response-successful-included-paymentInstrument"
                  },
                  "Successful ApplePay payment with included paymentInstrument": {
                    "$ref": "#/components/examples/payment-response-successful-apple-pay-included-paymentInstrument"
                  },
                  "Successful payment with new Card on File created": {
                    "$ref": "#/components/examples/payment-response-successful-cof-creation"
                  },
                  "Successful payment with installments plan successfully activated": {
                    "$ref": "#/components/examples/payment-response-successful-installments-plan"
                  },
                  "Successful payment with pspToken and pspCardFingerPrint": {
                    "$ref": "#/components/examples/payment-response-successful-psp-token"
                  },
                  "Successful payment with riskAssessments": {
                    "$ref": "#/components/examples/payment-response-successful-risk-assessment"
                  },
                  "Successful payment with unavailable risk engine": {
                    "$ref": "#/components/examples/payment-response-successful-no-risk-engine"
                  },
                  "Successful payment with included issuerResponse": {
                    "$ref": "#/components/examples/payment-response-successful-issuerResponse"
                  },
                  "Successful AFT payment": {
                    "$ref": "#/components/examples/aft-payment-response-yes"
                  }
                }
              }
            },
            "links": {
              "Get status of a Payment": {
                "operationId": "getPaymentStatusUsingGET",
                "parameters": {
                  "paymentId": "$response.body#/paymentId"
                },
                "description": "The `paymentId` value returned in the response can be used as the `paymentId` parameter in `GET /payments/{paymentId}/status`.\n"
              },
              "Refund a Payment": {
                "operationId": "createRefundUsingPOST",
                "parameters": {
                  "paymentId": "$response.body#/paymentId"
                },
                "description": "The `paymentId` value returned in the response can be used as the `paymentId` parameter in `POST /payments/{paymentId}/refund`.\n"
              }
            }
          },
          "202": {
            "description": "The operation has been accepted for processing and the outcome is not yet known.\nIf an action is in the response, please see [post-response-actions], otherwise please refer to the webhook callbacks that are linked to this operation.\n\n[post-response-actions]: https://docs.br-dge.io/docs/rest-api-introduction#post-response-actions\n",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/PaymentResponse"
                },
                "examples": {
                  "Further action required to make 3D-Secure payment": {
                    "$ref": "#/components/examples/payment-response-accepted-3ds-further-action"
                  },
                  "Further action required to make 3-D Secure payment with new Card on File": {
                    "$ref": "#/components/examples/payment-response-accepted-3ds-further-action-include-cof"
                  },
                  "Redirect Flow Action Response": {
                    "$ref": "#/components/examples/payment-response-accepted-redirect-flow"
                  },
                  "Pending": {
                    "$ref": "#/components/examples/payment-response-accepted-pending"
                  },
                  "Pending Skrill": {
                    "$ref": "#/components/examples/payment-response-accepted-pending-skrill"
                  }
                }
              }
            }
          },
          "400": {
            "description": "Bad request - the request was in an invalid format or contained invalid information.\n\nIf have any questions about why you are receiving these responses, please raise a ticket with support on the BR-DGE Support Portal at <https://docs.br-dge.io/docs/support#contact-support> with the `id` from the response so we track down the individual requests on our end.\n",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorResponse"
                },
                "examples": {
                  "Bad request with validation errors": {
                    "$ref": "#/components/examples/bad-request-with-validation-errors"
                  },
                  "Transaction declined due to risk engine's assessment": {
                    "$ref": "#/components/examples/bad-request-payment-declined-risk-assessment"
                  }
                }
              }
            }
          },
          "401": {
            "$ref": "#/components/responses/UnauthorizedRequest"
          },
          "409": {
            "description": "Indicates a request conflict.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/DuplicateMerchantTransactionIdError"
                },
                "examples": {
                  "Duplicate merchantTransactionId provided": {
                    "value": {
                      "code": "4701",
                      "message": "Duplicate Merchant Transaction ID",
                      "id": "4fad8e2e06a15656",
                      "merchantTransactionId": "yourUniqueRequestId"
                    }
                  }
                }
              }
            }
          },
          "422": {
            "$ref": "#/components/responses/UnprocessableContentRequest"
          },
          "500": {
            "$ref": "#/components/responses/UnknownServerError"
          },
          "502": {
            "$ref": "#/components/responses/BadGatewayNetworkError"
          }
        },
        "callbacks": {
          "Payment Status Change Events": {
            "https://example.com/BR-DGE/ as defined in your retail channel config": {
              "post": {
                "requestBody": {
                  "required": true,
                  "content": {
                    "application/json": {
                      "schema": {
                        "$ref": "#/components/schemas/PaymentStatusChangeEvent"
                      },
                      "examples": {
                        "authorization-pending": {
                          "$ref": "#/components/examples/authorization-pending"
                        },
                        "authorized": {
                          "$ref": "#/components/examples/authorized"
                        },
                        "authorized-with-payment-instrument-card": {
                          "$ref": "#/components/examples/authorized-payment-instrument-card"
                        },
                        "authorized-with-payment-instrument-apple-pay": {
                          "$ref": "#/components/examples/authorized-payment-instrument-apple-pay"
                        },
                        "authorized-with-payment-instrument-google-pay": {
                          "$ref": "#/components/examples/authorized-payment-instrument-google-pay"
                        },
                        "capture-pending": {
                          "$ref": "#/components/examples/capture-pending"
                        },
                        "captured": {
                          "$ref": "#/components/examples/captured"
                        },
                        "declined": {
                          "$ref": "#/components/examples/declined"
                        },
                        "rejected": {
                          "$ref": "#/components/examples/rejected"
                        },
                        "capture-failed": {
                          "$ref": "#/components/examples/capture-failed"
                        }
                      }
                    }
                  }
                },
                "responses": {
                  "200": {
                    "description": "Your server returns this code if it accepts the callback"
                  }
                }
              }
            }
          },
          "PSP Token Status Change Event": {
            "$ref": "#/components/callbacks/PspTokenStatusChangeEvent"
          },
          "PSP Token Provisioning Failed Event": {
            "$ref": "#/components/callbacks/PspTokenProvisioningFailedEvent"
          },
          "Network Token Provisioning Failed Event": {
            "$ref": "#/components/callbacks/NetworkTokenProvisioningFailedEvent"
          },
          "Network Token Status Change Event": {
            "$ref": "#/components/callbacks/NetworkTokenStatusChangeEvent"
          },
          "Network Token Metadata Update Event": {
            "$ref": "#/components/callbacks/NetworkTokenMetadataUpdateEvent"
          },
          "Payment Instrument Account Selection Event": {
            "$ref": "#/components/callbacks/PaymentInstrumentAccountSelectionEvent"
          }
        }
      }
    }
  },
  "components": {
    "schemas": {
      "PaymentRequest": {
        "title": "Payment",
        "description": "Represents a request to transfer funds between accounts at banks or other financial institutions.\n",
        "required": [
          "amount",
          "currencyCode",
          "customerOrderCode",
          "orderDescription",
          "paymentInstrument"
        ],
        "type": "object",
        "properties": {
          "amount": {
            "$ref": "#/components/schemas/AmountIncludingZero"
          },
          "billingAddress": {
            "$ref": "#/components/schemas/Address"
          },
          "browserData": {
            "$ref": "#/components/schemas/BrowserData"
          },
          "channel": {
            "type": "string",
            "enum": [
              "web",
              "ios",
              "android",
              "WEB",
              "IOS",
              "ANDROID"
            ],
            "example": "web",
            "description": "The type of channel used by the end user for the payment.\nE.g. If your user is using an iOS app to checkout then channel would be `ios`.\n\nThis data is required by some Payment Service Providers as part of their 3-D Secure flow.\nIf you are unsure whether you need to collect this data, please raise a ticket\nwith support on the BR-DGE Support Portal at\n<https://docs.br-dge.io/docs/support#contact-support>."
          },
          "currencyCode": {
            "$ref": "#/components/schemas/CurrencyCode"
          },
          "customerDateOfBirth": {
            "$ref": "#/components/schemas/DateOfBirth"
          },
          "customerEmail": {
            "maxLength": 254,
            "minLength": 1,
            "pattern": "^$|^[a-zA-Z0-9._%'+-]+@[a-zA-Z0-9.-]+\\.[a-zA-Z]{2,}$",
            "type": "string",
            "description": "Email address of the customer\nWhile this field is not required by the BR-DGE API; it is highly\nrecommended as some PSPs consider this a mandatory field.\nIf you have any questions about whether you should provide customer\nemail address, please raise a ticket with the\n[BR-DGE Support Centre](https://support.br-dge.io/support/home)",
            "example": "a@b.com"
          },
          "customerFirstName": {
            "description": "First name of the customer (customerFirstName length plus customerLastName length must be less than 255 characters long) Please use only letters, spaces and these symbols: `-'.` While this field is not required by the BR-DGE API; it is highly recommended as some PSPs consider this a mandatory field. If you have any questions about whether you should provide customer first name, please raise a ticket with the [BR-DGE Support Centre](https://support.br-dge.io/support/home)",
            "type": "string",
            "minLength": 1,
            "maxLength": 255,
            "example": "John"
          },
          "customerId": {
            "$ref": "#/components/schemas/CustomerId"
          },
          "customerIpAddress": {
            "$ref": "#/components/schemas/IpAddress"
          },
          "customerLastName": {
            "description": "Last name of the customer (customerFirstName length plus customerLastName length must be less than 255 characters long)\nPlease use only letters, spaces and these symbols: -'.",
            "type": "string",
            "maxLength": 255,
            "example": "Smith"
          },
          "customerOrderCode": {
            "allOf": [
              {
                "$ref": "#/components/schemas/CustomerOrderCode"
              }
            ],
            "description": "Merchant’s own identifier for the transaction, which can be used to find the transaction in BR-DGE Portal.\nThis value will also be passed on to payment service providers if possible.\n\n\nPlease use only letters, numbers, spaces and these symbols:'[]()@?!\\-/.,_&*:;+="
          },
          "customerPhoneNumber": {
            "maxLength": 255,
            "pattern": "^$|^[+]?[(0-9][0-9 ()-]*[0-9]$",
            "type": "string",
            "description": "Telephone number of the customer\nPlease use only numbers, spaces and an optional leading +.",
            "example": "+44 123 1110000"
          },
          "customerSessionId": {
            "$ref": "#/components/schemas/CustomerSessionId"
          },
          "deliveryAddress": {
            "$ref": "#/components/schemas/Address"
          },
          "documentId": {
            "maxLength": 255,
            "type": "string",
            "description": "Required for some payment instruments. Please refer to the payment instrument schema\ndocumentation to see if this is required and where to source the data.",
            "example": "ABC-123456"
          },
          "documentType": {
            "maxLength": 255,
            "type": "string",
            "description": "The type of identification document. E.g. passport, national identity card, tax ID, etc.\nRequired for some payment instruments. Please refer to the payment instrument schema documentation to see if this is required and where to source the data.\n",
            "example": "DNI"
          },
          "intent": {
            "type": "string",
            "default": "capture",
            "description": "By default payments are captured immediately, but you can you can choose to split the authorization and the capture of the payment.\n * `authorize` - if you intend to capture separately using\n   `POST /payments/{paymentId}/capture`\n * `capture` - If you intend to capture immediately\n",
            "enum": [
              "authorize",
              "capture"
            ]
          },
          "merchantInitiated": {
            "type": "string",
            "description": "Payments made via BR-DGE are assumed to be Cardholder Initiated Transactions (CIT) unless flagged as Merchant Initiated (MIT).\n\nMerchants commonly initiate MITs without the active participation of the cardholder to:\n- Perform a transaction as a follow-up to a cardholder-initiated transaction (CIT)\n- Perform a pre-agreed standing instruction from the cardholder for the provision of goods or services\n\nExamples of MITs include:\n- An unscheduled charge for a service such as e-scooter hire\n- A recurring payment for a magazine subscription\n\nYou must enter into an agreement with your customer prior to performing MITs, and must use a BR-DGE Card on File Payment Instrument.\n",
            "enum": [
              "unscheduled",
              "recurring"
            ]
          },
          "merchantInitiatedDetails": {
            "$ref": "#/components/schemas/MerchantInitiatedDetails"
          },
          "orderDescription": {
            "maxLength": 255,
            "minLength": 1,
            "type": "string",
            "description": "Description of what the payment is for\nPlease use only letters, numbers, spaces and these symbols:'[]()@?!\\-/.,_&*:;+=",
            "example": "Taxi fare"
          },
          "origin": {
            "type": "string",
            "maxLength": 255,
            "minLength": 1,
            "example": "https://example-store.org:8080",
            "description": "The origin URL of the web page used by the end user for the payment,\nif the `channel` is `web`.\n\nThis data is required by some payment service providers (PSPs) as part of their\n3-D Secure flow.\nIf you are unsure whether you need to collect this data, please raise a ticket with\nsupport on the BR-DGE Support Portal at\n<https://docs.br-dge.io/docs/support#contact-support>."
          },
          "paymentInstrument": {
            "$ref": "#/components/schemas/PaymentInstrument"
          },
          "threeDSecureOptions": {
            "$ref": "#/components/schemas/ThreeDSecureOptions"
          },
          "threeDSecureRequired": {
            "type": "boolean",
            "description": "You can indicate that 3-D Secure processing is preferred, usually initializing a 3-D Secure authentication flow.\n\nNote that setting this as true does not guarantee that the payment will end up with successful 3-D Secure authentication. Also, setting this to false does not guarantee that 3-D Secure authentication will not be applied to the payment, as some PSPs may choose to apply their own rules around this regardless need to opt-in to 3-D Secure authentication on a per-payment basis.\n",
            "example": true
          },
          "externalThreeDSecure": {
            "$ref": "#/components/schemas/ExternalThreeDSecure"
          },
          "ignoreAvs": {
            "type": "boolean",
            "description": "You can tell the payment processors to ignore the result of their Address Verification Service (AVS) and process the Payment regardless. This is false by default.\n\nNote this only applies to some payment processors. Speak to your payment processor to find out how you can ignore their AVS otherwise.\n",
            "example": true
          },
          "riskInstruments": {
            "$ref": "#/components/schemas/RiskInstruments"
          },
          "cashierId": {
            "$ref": "#/components/schemas/CashierId"
          },
          "merchantTransactionId": {
            "$ref": "#/components/schemas/MerchantTransactionId"
          },
          "scaExemption": {
            "type": "string",
            "description": "This field allows you to specify a reason for exempting a transaction from Strong Customer Authentication (SCA).\n- LOW_VALUE - Low-Value Transaction. Use this value if the transaction amount is below the threshold for SCA exemption.\n- TRA - Transaction Risk Analysis. Use this value if you believe the transaction has a low risk of fraud based on your own risk assessment.\n\nNOTE: Even with a valid exemption reason, the card issuer has the final say in whether to grant the exemption.\n",
            "enum": [
              "LOW_VALUE",
              "TRA"
            ],
            "example": "TRA"
          },
          "aft": {
            "type": "object",
            "description": "Indicates if the payment is an Account Funding Transaction.\n\nPlease provide the required sender and recipient data required by the PSP of choice.\n",
            "properties": {
              "fundingPurpose": {
                "type": "string",
                "enum": [
                  "DONATIONS",
                  "EDUCATION",
                  "FAMILY_SUPPORT",
                  "GIFTS",
                  "LOAN_PAYMENT",
                  "MEDICAL_TREATMENT",
                  "OTHER",
                  "SAVINGS"
                ],
                "description": "The funding purpose of the AFT payment.\n"
              },
              "fundingType": {
                "type": "string",
                "enum": [
                  "PERSON_TO_PERSON",
                  "DIGITAL_WALLET_TOP_UP"
                ],
                "description": "The funding type of the AFT payment.\n"
              }
            }
          },
          "recipient": {
            "$ref": "#/components/schemas/PaymentRecipient"
          },
          "customMetadata": {
            "$ref": "#/components/schemas/CustomMetadata"
          }
        }
      },
      "CustomerSessionId": {
        "title": "Customer Session ID",
        "type": "string",
        "maxLength": 255,
        "description": "Session Id of the customer\nPlease use only letters, numbers, spaces and these symbols:'[]()@?!\\-/.,_&*:;+=",
        "example": "123456"
      },
      "Address": {
        "title": "Address",
        "allOf": [
          {
            "type": "object",
            "properties": {
              "firstName": {
                "description": "First name of the occupant.\n\nPlease use only letters, spaces and these symbols: `-'.`",
                "type": "string",
                "maxLength": 255,
                "example": "John"
              },
              "lastName": {
                "description": "Last name of the occupant.\n\nPlease use only letters, spaces and these symbols: `-'.`",
                "type": "string",
                "maxLength": 255,
                "example": "Smith"
              },
              "phoneNumber": {
                "$ref": "#/components/schemas/PhoneNumber"
              }
            }
          },
          {
            "$ref": "#/components/schemas/DomicileAddress"
          }
        ]
      },
      "DomicileAddress": {
        "title": "Address",
        "type": "object",
        "properties": {
          "buildingNumberOrName": {
            "$ref": "#/components/schemas/BuildingNumberOrName"
          },
          "address1": {
            "$ref": "#/components/schemas/AddressLineOne"
          },
          "address2": {
            "$ref": "#/components/schemas/AddressLineTwo"
          },
          "address3": {
            "$ref": "#/components/schemas/AddressLineThree"
          },
          "town": {
            "$ref": "#/components/schemas/Town"
          },
          "county": {
            "$ref": "#/components/schemas/County"
          },
          "postcode": {
            "$ref": "#/components/schemas/Postcode"
          },
          "country": {
            "$ref": "#/components/schemas/CountryIsoCode"
          },
          "countrySubdivisionCode": {
            "description": "ISO 3166-2 Country subdivision code.\n\nFor an ISO 3166-2 code like `GB-SCT` you should only provide `SCT`.",
            "type": "string",
            "minLength": 1,
            "maxLength": 3,
            "pattern": "^[A-Z0-9]+$",
            "example": "WY"
          }
        }
      },
      "BrowserData": {
        "title": "BrowserData",
        "description": "Information about the browser used to collect payment details.\n\nThis data is required by some Payment Service Providers as part of their 3-D Secure flow. If you are unsure whether you need to collect this data, please raise a ticket with support on the BR-DGE Support Portal at <https://docs.br-dge.io/docs/support#contact-support>.\n",
        "type": "object",
        "properties": {
          "acceptHeader": {
            "type": "string",
            "description": "Exact content of the HTTP accept headers as sent to the merchant from the cardholders browser.\n",
            "example": "application/json"
          },
          "colorDepth": {
            "type": "string",
            "description": "Value representing the bit depth of the color palette for displaying images, in bits per pixel. Obtained from cardholder browser using the `screen.colorDepth` browser property.",
            "example": "32"
          },
          "javaEnabled": {
            "type": "boolean",
            "description": "Boolean that represents the ability of the cardholder browser to execute java. Value is returned from the `navigator.javaEnabled` browser property.",
            "example": true
          },
          "language": {
            "type": "string",
            "description": "Value representing the browser language as defined in IETF BCP47. Returned from `navigator.language` browser property.",
            "example": "en-GB"
          },
          "screenHeight": {
            "type": "integer",
            "description": "Total height of the cardholders screen in pixels. Value is returned from the `screen.height` browser property.",
            "format": "int32",
            "example": 768
          },
          "screenWidth": {
            "type": "integer",
            "description": "Total width of the cardholders screen in pixels. Value is returned from the `screen.width` browser property.",
            "format": "int32",
            "example": 1024
          },
          "timeZone": {
            "type": "integer",
            "description": "Time difference between UTC time and the cardholder browser local time, in minutes.\n\nThis can be retrieved by running `new Date().getTimezoneOffset();` within the browser.",
            "format": "int32",
            "example": 800
          },
          "userAgent": {
            "type": "string",
            "description": "Exact content of the HTTP user-agent header, as sent to the merchant from the cardholders browser.",
            "example": "Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36"
          }
        }
      },
      "ExternalThreeDSecure": {
        "description": "If you want to use an independent 3-D Secure service to authenticate your payment, then you can do so prior to submitting your payment to BR-DGE.\n\nYour client app sends the payment details to your server.\n\nYour server submits the payment to your 3-D Secure Authentication Service\n\nThe 3-D Authentication service will authenticate the payment and return the authentication results back to your server. It will include several fields that can be used by the issuer to confirm the authentication results as part of approving the payment.\n\nAfter authentication, the results can be added to the payment and submitted to BR-DGE for processing. Click here for details on the fields that can be included in the BR-DGE API\n",
        "type": "object",
        "properties": {
          "eci": {
            "type": "string",
            "description": "The Electronic Commerce Indicator (ECI) indicates the type of card holder authentication used for the transaction.\n\nFor Secure, Authenticated transaction with XID and CAVV present ECI is set to \"05\" (Visa & eftpos) or \"02\" (Mastercard). For Secure, Non-authenticated transaction (XID present, CAVV not present) ECI is set to \"06\" (Visa & eftpos) or \"01\" (Mastercard). For Secure, Non-authenticated transaction (XID and CAVV not present) ECI is set to \"07\" (Visa & eftpos) or \"00\" (Mastercard).\n",
            "example": "05"
          },
          "cavv": {
            "type": "string",
            "description": "The CAVV is the card authentication verification value, provided by the 3D Secure Provider. This is Base64 encoded data.",
            "example": "MzM2OGI2ZjkwYjYwY2FjODQ3ZWU="
          },
          "xid": {
            "type": "string",
            "description": "The XID is the transaction ID from the 3D Secure provider. This is Base64 encoded data.",
            "example": "ZGUzNzgwYzQxM2ZlMWM0MzVkMjc="
          },
          "par": {
            "type": "string",
            "description": "This is the PARes value from 3D Secure",
            "example": "Y"
          },
          "ver": {
            "type": "string",
            "description": "This is the VERes value from 3D Secure",
            "example": "Y"
          },
          "threeDSecureVersion": {
            "type": "string",
            "description": "3DS version used for authenticating the card. The version may include the major, minor, and build numbers, e.g. 2, 2.1, or 2.1.0 are all accepted values. If omitted, this field will default to a value of 1.",
            "example": "2.1.0"
          },
          "dsTransactionId": {
            "type": "string",
            "description": "Directory Server Transaction ID from the 3D Secure provider. This is commonly a string in UUID format.",
            "example": "2.1.0"
          }
        }
      },
      "PaymentResponse": {
        "description": "The response from a payment request.",
        "allOf": [
          {
            "$ref": "#/components/schemas/ComcardeResponse"
          },
          {
            "$ref": "#/components/schemas/RelationshipEntity"
          },
          {
            "$ref": "#/components/schemas/IncludedRelationships"
          },
          {
            "type": "object",
            "title": "PaymentResponse",
            "properties": {
              "paymentId": {
                "type": "string",
                "description": "The ID of this payment",
                "example": "57f7f444-29ce-4230-8c7f-1c1fd85c8bc9"
              },
              "amount": {
                "$ref": "#/components/schemas/AmountIncludingZero"
              },
              "currencyCode": {
                "$ref": "#/components/schemas/CurrencyCode"
              },
              "threeDSecureAction": {
                "type": "object",
                "additionalProperties": {
                  "type": "string"
                },
                "description": "An object that contains values used to continue a 3-D Secure payment.\n\nNote: this field is now deprecated, and the 'action' field should be used instead.\n",
                "deprecated": true
              },
              "actionRequired": {
                "type": "boolean",
                "description": "Boolean value indicating whether further action should be taken after the response is received",
                "example": true
              },
              "action": {
                "$ref": "#/components/schemas/Action"
              },
              "installmentsPlan": {
                "$ref": "#/components/schemas/InstallmentsPlan"
              },
              "token": {
                "type": "string",
                "description": "Multi-use token for Card on File, if the request asked for one to be created.\n",
                "example": "7685edd8-006b-4526-85ce-c8b31addcea6"
              },
              "psp": {
                "$ref": "#/components/schemas/PspInfo"
              },
              "pspId": {
                "type": "string",
                "description": "Deprecated. Use `psp` object instead.",
                "deprecated": true
              },
              "riskAssessments": {
                "$ref": "#/components/schemas/RiskAssessments"
              },
              "customerOrderCode": {
                "allOf": [
                  {
                    "$ref": "#/components/schemas/CustomerOrderCode"
                  }
                ],
                "description": "Merchant's own identifier for the transaction, which can be used to find the transaction in BR-DGE Portal.\n",
                "example": "ABC123"
              },
              "merchantTransactionId": {
                "$ref": "#/components/schemas/MerchantTransactionId"
              },
              "paymentRails": {
                "$ref": "#/components/schemas/PaymentRails"
              },
              "avsResult": {
                "$ref": "#/components/schemas/AvsResult"
              },
              "cvvResult": {
                "$ref": "#/components/schemas/CvvResult"
              },
              "paymentInstrument": {
                "$ref": "#/components/schemas/PaymentInstrumentPaymentResponse"
              },
              "scaDetails": {
                "$ref": "#/components/schemas/ScaDetails"
              },
              "authentication": {
                "$ref": "#/components/schemas/Authentication"
              },
              "authorizationCode": {
                "$ref": "#/components/schemas/AuthorizationCode"
              },
              "blockingRule": {
                "$ref": "#/components/schemas/BlockingRule"
              },
              "processedAsAft": {
                "$ref": "#/components/schemas/ProcessedAsAft"
              },
              "pspProcessingMethod": {
                "$ref": "#/components/schemas/PspProcessingMethod"
              }
            }
          }
        ]
      },
      "ProcessedAsAft": {
        "title": "ProcessedAsAft",
        "type": "string",
        "description": "Indicator whether the payment was processed as an AFT. `UNKNOWN` when the provider does not report either way. Only present for payments submitted with an `aft` object.\n",
        "enum": [
          "YES",
          "NO",
          "UNKNOWN"
        ],
        "example": "YES"
      },
      "PspProcessingMethod": {
        "title": "PspProcessingMethod",
        "type": "string",
        "description": "The type of payment credential BR-DGE submitted to the provider to process this transaction, typically `RAW_CARD_DETAILS`, `NETWORK_TOKEN`, `PSP_TOKEN` or `OTHER`. Describes what BR-DGE sent to the provider, not what the provider used. Omitted when no credential type was recorded.\n",
        "example": "NETWORK_TOKEN"
      },
      "InstallmentsPlan": {
        "title": "InstallmentsPlan",
        "description": "Information about any installments plan was that was linked to the payment request and the outcome of its activation or acceptance.\n",
        "type": "object",
        "properties": {
          "code": {
            "type": "string",
            "description": "[Response Code](https://docs.br-dge.io/docs/response-codes) signifying the outcome of the request.\n",
            "example": "1000"
          },
          "message": {
            "type": "string",
            "description": "A description of the outcome of the request.",
            "example": "Approved"
          },
          "provider": {
            "type": "string",
            "description": "Full name of the provider of this installments plan.",
            "example": "Visa Installments"
          },
          "operation": {
            "type": "string",
            "description": "The type of operation being made: Activation: a new plan has been activated Cancellation: an existing plan has been cancelled\n",
            "example": "cancellation"
          },
          "planActivationId": {
            "type": "string",
            "description": "Unique code that identifies the acceptance or activation of the installments plan. This code comes from the installments plan provider, not from BR-DGE.\n",
            "example": "6ccc5c91-f869-4063-9368-40b4cb30c6ce"
          }
        }
      },
      "PaymentInstrumentPaymentResponse": {
        "oneOf": [
          {
            "$ref": "#/components/schemas/PaymentInstrumentCard"
          },
          {
            "$ref": "#/components/schemas/PaymentInstrumentApplePay"
          },
          {
            "$ref": "#/components/schemas/PaymentInstrumentGooglePay"
          },
          {
            "$ref": "#/components/schemas/PaymentInstrumentClickToPay"
          },
          {
            "$ref": "#/components/schemas/PaymentStatusPaymentInstrumentPayPal"
          },
          {
            "$ref": "#/components/schemas/PaymentStatusPaymentInstrumentIdeal"
          },
          {
            "$ref": "#/components/schemas/PaymentStatusPaymentInstrumentBancontact"
          },
          {
            "$ref": "#/components/schemas/PaymentStatusPaymentInstrumentTrustly"
          },
          {
            "$ref": "#/components/schemas/PaymentStatusPaymentInstrumentPix"
          },
          {
            "$ref": "#/components/schemas/PaymentInstrumentPspTokenInstrument"
          },
          {
            "$ref": "#/components/schemas/PaymentStatusPaymentInstrumentAstroPayInstrument"
          },
          {
            "$ref": "#/components/schemas/PaymentStatusPaymentInstrumentPaysafecard"
          },
          {
            "$ref": "#/components/schemas/PaymentStatusPaymentInstrumentEasyPay"
          },
          {
            "$ref": "#/components/schemas/PaymentStatusPaymentInstrumentEPay"
          },
          {
            "$ref": "#/components/schemas/PaymentStatusPaymentInstrumentNeteller"
          },
          {
            "$ref": "#/components/schemas/PaymentStatusPaymentInstrumentSkrill"
          },
          {
            "$ref": "#/components/schemas/PaymentStatusPaymentInstrumentRevolutPay"
          },
          {
            "$ref": "#/components/schemas/PaymentStatusPaymentInstrumentTrueLayer"
          },
          {
            "$ref": "#/components/schemas/PaymentStatusPaymentInstrumentOneVoucher"
          },
          {
            "$ref": "#/components/schemas/PaymentStatusPaymentInstrumentBluVoucher"
          },
          {
            "$ref": "#/components/schemas/PaymentStatusPaymentInstrumentBank2Bank"
          },
          {
            "$ref": "#/components/schemas/PaymentStatusPaymentInstrumentOttVoucher"
          }
        ],
        "discriminator": {
          "propertyName": "type",
          "mapping": {
            "card": "#/components/schemas/PaymentInstrumentCard",
            "applePay": "#/components/schemas/PaymentInstrumentApplePay",
            "googlePay": "#/components/schemas/PaymentInstrumentGooglePay",
            "clickToPay": "#/components/schemas/PaymentInstrumentClickToPay",
            "payPal": "#/components/schemas/PaymentStatusPaymentInstrumentPayPal",
            "ideal": "#/components/schemas/PaymentStatusPaymentInstrumentIdeal",
            "bancontact": "#/components/schemas/PaymentStatusPaymentInstrumentBancontact",
            "trustly": "#/components/schemas/PaymentStatusPaymentInstrumentTrustly",
            "pix": "#/components/schemas/PaymentStatusPaymentInstrumentPix",
            "pspToken": "#/components/schemas/PaymentInstrumentPspTokenInstrument",
            "astroPay": "#/components/schemas/PaymentStatusPaymentInstrumentAstroPayInstrument",
            "paysafecard": "#/components/schemas/PaymentStatusPaymentInstrumentPaysafecard",
            "easyPay": "#/components/schemas/PaymentStatusPaymentInstrumentEasyPay",
            "ePay": "#/components/schemas/PaymentStatusPaymentInstrumentEPay",
            "neteller": "#/components/schemas/PaymentStatusPaymentInstrumentNeteller",
            "skrill": "#/components/schemas/PaymentStatusPaymentInstrumentSkrill",
            "revolutPay": "#/components/schemas/PaymentStatusPaymentInstrumentRevolutPay",
            "trueLayer": "#/components/schemas/PaymentStatusPaymentInstrumentTrueLayer",
            "oneVoucher": "#/components/schemas/PaymentStatusPaymentInstrumentOneVoucher",
            "bluVoucher": "#/components/schemas/PaymentStatusPaymentInstrumentBluVoucher",
            "bank2bank": "#/components/schemas/PaymentStatusPaymentInstrumentBank2Bank",
            "ottVoucher": "#/components/schemas/PaymentStatusPaymentInstrumentOttVoucher"
          }
        }
      },
      "BasePaymentStatusPaymentInstrument": {
        "description": "General fields which are valid for a payment instrument.",
        "type": "object",
        "required": [
          "type"
        ],
        "properties": {
          "type": {
            "description": "Discriminator Field, defines the type of payment instrument.\nValid values can be found on the parent object’s discriminator definition in OpenAPI schema.\n",
            "type": "string"
          }
        }
      },
      "PaymentInstrumentCard": {
        "allOf": [
          {
            "$ref": "#/components/schemas/BasePaymentStatusPaymentInstrument"
          },
          {
            "type": "object"
          }
        ]
      },
      "PaymentInstrumentApplePay": {
        "allOf": [
          {
            "$ref": "#/components/schemas/BasePaymentStatusPaymentInstrument"
          },
          {
            "type": "object"
          }
        ]
      },
      "PaymentInstrumentGooglePay": {
        "allOf": [
          {
            "$ref": "#/components/schemas/BasePaymentStatusPaymentInstrument"
          },
          {
            "type": "object"
          }
        ]
      },
      "PaymentInstrumentClickToPay": {
        "allOf": [
          {
            "$ref": "#/components/schemas/BasePaymentStatusPaymentInstrument"
          },
          {
            "type": "object"
          }
        ]
      },
      "PaymentStatusPaymentInstrumentPayPal": {
        "allOf": [
          {
            "$ref": "#/components/schemas/BasePaymentStatusPaymentInstrument"
          },
          {
            "type": "object",
            "properties": {
              "account": {
                "$ref": "#/components/schemas/PaymentInstrumentAccountBase"
              }
            }
          }
        ]
      },
      "PaymentStatusPaymentInstrumentIdeal": {
        "allOf": [
          {
            "$ref": "#/components/schemas/BasePaymentStatusPaymentInstrument"
          },
          {
            "type": "object"
          }
        ]
      },
      "PaymentInstrumentAccountBase": {
        "title": "Account",
        "type": "object",
        "properties": {
          "accountId": {
            "type": "string",
            "description": "The unique account identifier used by the payment instrument provider (Skrill, Paypal etc.) The id is only available after the customer has logged in to their account. Only supported on a subset of payment instruments.\n",
            "example": "customer@email.com"
          }
        }
      },
      "TrueLayerUserData": {
        "description": "Contains TrueLayer customer account information.\n",
        "type": "object",
        "properties": {
          "title": {
            "type": "string",
            "description": "Title of the customer.",
            "example": "Mr"
          },
          "firstName": {
            "type": "string",
            "description": "First name of the customer.",
            "example": "John"
          },
          "lastName": {
            "type": "string",
            "description": "Last name of the customer.",
            "example": "Smith"
          },
          "dateOfBirth": {
            "$ref": "#/components/schemas/DateOfBirth"
          },
          "address": {
            "$ref": "#/components/schemas/Address"
          },
          "accountDetails": {
            "$ref": "#/components/schemas/TrueLayerAccountDetails"
          }
        }
      },
      "TrueLayerAccountDetails": {
        "description": "TrueLayer Account Details",
        "type": "object",
        "properties": {
          "accountNumber": {
            "$ref": "#/components/schemas/AccountNumber"
          },
          "sortCode": {
            "$ref": "#/components/schemas/SortCode"
          },
          "iban": {
            "$ref": "#/components/schemas/Iban"
          },
          "providerId": {
            "type": "string",
            "description": "The TrueLayer ID of a bank or other financial institution.",
            "example": "gb-monzo"
          },
          "paymentSourceId": {
            "description": "The TrueLayer ID of the customer's payment details.",
            "type": "string",
            "example": "ff411383-f513-4b08-b012-69815bd80568"
          }
        }
      },
      "PaymentStatusPaymentInstrumentBancontact": {
        "allOf": [
          {
            "$ref": "#/components/schemas/BasePaymentStatusPaymentInstrument"
          },
          {
            "type": "object"
          }
        ]
      },
      "PaymentStatusPaymentInstrumentTrustly": {
        "allOf": [
          {
            "$ref": "#/components/schemas/BasePaymentStatusPaymentInstrument"
          },
          {
            "type": "object",
            "properties": {
              "account": {
                "allOf": [
                  {
                    "$ref": "#/components/schemas/TrustlyAccount"
                  },
                  {
                    "required": [
                      "accountId"
                    ]
                  }
                ]
              }
            }
          }
        ]
      },
      "PaymentStatusPaymentInstrumentPix": {
        "allOf": [
          {
            "$ref": "#/components/schemas/BasePaymentStatusPaymentInstrument"
          },
          {
            "type": "object"
          }
        ]
      },
      "PaymentInstrumentPspTokenInstrument": {
        "allOf": [
          {
            "$ref": "#/components/schemas/BasePaymentStatusPaymentInstrument"
          },
          {
            "type": "object"
          }
        ]
      },
      "PaymentStatusPaymentInstrumentAstroPayInstrument": {
        "allOf": [
          {
            "$ref": "#/components/schemas/BasePaymentStatusPaymentInstrument"
          },
          {
            "type": "object"
          }
        ]
      },
      "PaymentStatusPaymentInstrumentPaysafecard": {
        "allOf": [
          {
            "$ref": "#/components/schemas/BasePaymentStatusPaymentInstrument"
          },
          {
            "type": "object",
            "properties": {
              "account": {
                "$ref": "#/components/schemas/PaymentInstrumentAccountBase"
              }
            }
          }
        ]
      },
      "PaymentStatusPaymentInstrumentNeteller": {
        "allOf": [
          {
            "$ref": "#/components/schemas/BasePaymentStatusPaymentInstrument"
          },
          {
            "type": "object",
            "properties": {
              "account": {
                "$ref": "#/components/schemas/PaymentInstrumentAccountBase"
              }
            }
          }
        ]
      },
      "PaymentStatusPaymentInstrumentEasyPay": {
        "allOf": [
          {
            "$ref": "#/components/schemas/BasePaymentStatusPaymentInstrument"
          },
          {
            "type": "object"
          }
        ]
      },
      "PaymentStatusPaymentInstrumentEPay": {
        "allOf": [
          {
            "$ref": "#/components/schemas/BasePaymentStatusPaymentInstrument"
          },
          {
            "type": "object"
          }
        ]
      },
      "PaymentStatusPaymentInstrumentSkrill": {
        "allOf": [
          {
            "$ref": "#/components/schemas/BasePaymentStatusPaymentInstrument"
          },
          {
            "type": "object",
            "properties": {
              "account": {
                "$ref": "#/components/schemas/PaymentInstrumentAccountBase"
              }
            }
          }
        ]
      },
      "PaymentStatusPaymentInstrumentRevolutPay": {
        "allOf": [
          {
            "$ref": "#/components/schemas/BasePaymentStatusPaymentInstrument"
          },
          {
            "type": "object"
          }
        ]
      },
      "PaymentStatusPaymentInstrumentTrueLayer": {
        "allOf": [
          {
            "$ref": "#/components/schemas/BasePaymentStatusPaymentInstrument"
          },
          {
            "type": "object",
            "properties": {
              "userData": {
                "$ref": "#/components/schemas/TrueLayerUserData"
              }
            }
          }
        ]
      },
      "PaymentStatusPaymentInstrumentOneVoucher": {
        "allOf": [
          {
            "$ref": "#/components/schemas/BasePaymentStatusPaymentInstrument"
          },
          {
            "type": "object"
          }
        ]
      },
      "PaymentStatusPaymentInstrumentBluVoucher": {
        "allOf": [
          {
            "$ref": "#/components/schemas/BasePaymentStatusPaymentInstrument"
          },
          {
            "type": "object"
          }
        ]
      },
      "PaymentStatusPaymentInstrumentBank2Bank": {
        "allOf": [
          {
            "$ref": "#/components/schemas/BasePaymentStatusPaymentInstrument"
          },
          {
            "type": "object"
          }
        ]
      },
      "PaymentStatusPaymentInstrumentOttVoucher": {
        "allOf": [
          {
            "$ref": "#/components/schemas/BasePaymentStatusPaymentInstrument"
          },
          {
            "type": "object"
          }
        ]
      },
      "RiskAssessments": {
        "description": "An optional map of risk assessment results received from risk engines.",
        "type": "object",
        "properties": {
          "kount": {
            "$ref": "#/components/schemas/KountRiskAssessment"
          },
          "merchant": {
            "$ref": "#/components/schemas/MerchantRiskAssessment"
          }
        }
      },
      "KountRiskAssessment": {
        "description": "Risk assessment from Kount risk engine.",
        "type": "object",
        "required": [
          "decision"
        ],
        "properties": {
          "score": {
            "description": "The [Omniscore] transaction safety rating received from Kount's risk engine.\n\n[Omniscore]: https://support.kount.com/hc/en-us/articles/360045236712-Omniscore-Overview\n",
            "type": "number",
            "format": "double",
            "example": 85.5
          },
          "decision": {
            "description": "Kount's risk decision\n\nCan be one of:\n- `APPROVED`: Kount risk engine has approved the transaction.\n- `DECLINED`: Kount risk engine has declined the transaction.\n- `UNAVAILABLE`: Kount risk engine was unavailable to give a decision.\n- `REVIEW`: Kount risk engine has advised that manual review of transaction is required.\n",
            "type": "string",
            "enum": [
              "APPROVED",
              "DECLINED",
              "UNAVAILABLE",
              "REVIEW"
            ],
            "example": "APPROVED"
          },
          "reasonCode": {
            "description": "The **reasonCode** indicates a [Custom Reason Code] you've configured within your Kount dashboard. This code is returned when a specific individual rule you've created in Kount is triggered.\n\nTo manage or add new custom reason codes and their associated rules, please use your Kount dashboard.\n\n[Custom Reason Code]: https://support.kount.com/hc/en-us/articles/360045746411-Set-Up-Custom-Reason-Codes\n",
            "type": "string",
            "example": "APPROVED_3DS_STEP_UP"
          },
          "transactionId": {
            "description": "Transaction identifier provided by Kount.",
            "type": "string"
          },
          "tags": {
            "description": "List of tags assigned to the transaction by Kount.",
            "type": "array",
            "nullable": true,
            "items": {
              "type": "string"
            },
            "example": [
              "3DS_CHALLENGE",
              "NEW_DEVICE"
            ]
          }
        }
      },
      "MerchantRiskAssessment": {
        "description": "Risk assessment from Merchant's own risk engine. Can be used to return results when\nthe merchant has a proprietary risk or validation engine they wish to call during the\npayment or payout flows.\n",
        "type": "object",
        "required": [
          "decision"
        ],
        "properties": {
          "decision": {
            "description": "Merchant's decision\n\nCan be one of:\n- `APPROVED`: Merchant's risk engine has approved the transaction.\n- `DECLINED`: Merchant's risk engine has declined the transaction.\n- `UNAVAILABLE`: Merchant's risk engine was unavailable to give a decision.\n- `HELD`: Merchant’s risk engine has placed the transaction on hold\n",
            "type": "string",
            "enum": [
              "APPROVED",
              "DECLINED",
              "UNAVAILABLE",
              "HELD"
            ],
            "example": "APPROVED"
          },
          "code": {
            "description": "The response code returned by the engine.",
            "type": "string"
          },
          "message": {
            "description": "Message returned by the engine.",
            "type": "string"
          },
          "retryable": {
            "description": "Indicates whether transaction can be amended and retried.",
            "type": "boolean",
            "example": true
          },
          "transactionId": {
            "description": "Transaction identifier returned by the Merchant risk engine.",
            "type": "string"
          },
          "rawResponse": {
            "$ref": "#/components/schemas/RawResponse"
          }
        }
      },
      "RiskInstruments": {
        "type": "object",
        "description": "Map of optional risk instrument objects which can be used to pass risk information to PSPs or risk engines\n",
        "properties": {
          "checkoutRiskJs": {
            "$ref": "#/components/schemas/CheckoutRiskJs"
          },
          "kount": {
            "$ref": "#/components/schemas/Kount"
          },
          "merchant": {
            "$ref": "#/components/schemas/Merchant"
          }
        }
      },
      "Card": {
        "title": "Card",
        "description": "A type of [Payment Instrument] representing a credit or debit payment card.\n\n[Payment Instrument]: https://docs.br-dge.io/docs/introduction#payment-instrument\n",
        "type": "object",
        "required": [
          "expiryDate",
          "pan",
          "type"
        ],
        "properties": {
          "type": {
            "type": "string",
            "description": "Discriminator field. Please see the discriminator mapping for the `PaymentInstrument` schema."
          },
          "nameOnCard": {
            "maxLength": 45,
            "minLength": 2,
            "type": "string",
            "description": "Name on the credit or debit card\nPlease use only letters, numbers, spaces and these symbols: -'.",
            "example": "John F Doe"
          },
          "pan": {
            "type": "string",
            "maxLength": 19,
            "minLength": 14,
            "description": "PAN of the credit or debit card.",
            "example": "4444 3333 2222 1111"
          },
          "expiryDate": {
            "$ref": "#/components/schemas/CardExpiryDate"
          },
          "startDate": {
            "type": "string",
            "description": "Start date of the credit or debit card.",
            "example": "01-00"
          },
          "issueNumber": {
            "maximum": 9,
            "minimum": 1,
            "type": "integer",
            "description": "Issue number of the credit or debit card.",
            "format": "int32",
            "example": 1
          },
          "cv2": {
            "maximum": 4,
            "minimum": 3,
            "pattern": "^[0-9]*$",
            "type": "string",
            "description": "CV2 of the credit or debit card\nPlease use only numbers",
            "example": "123"
          },
          "tokenize": {
            "type": "boolean",
            "description": "If true, then a Card-on-File will be created.\nIf Vault interoperability is enabled on your BR-DGE Retail Channel, PSP tokens will also\nbe provisioned.",
            "example": false
          },
          "storedCredentialIndicator": {
            "type": "string",
            "description": "Indicates whether a card has been stored externally to our system,\nand if it has been used previously.\n\nUsed for the situation where you have previously used and stored the card outside\nour system.  This will override the value sent to the card networks, (e.g. Visa/Mastercard)\non the *first* time the card is used within our systems.\n\nIf your systems don't ever store card details *this field should be ignored*.\n\nWhen sent to us this affects the first time the tokenized card is used within our systems.\nIn the case of a card that you never want tokenized with us, but is tokenized externally,\nwe will require the correct value on every call.\n\nThis is related to [Credential on file mandate compliance](https://docs.br-dge.io/docs/vault#credentials-on-file-mandate-compliance).\n\n## Possible Values\n\n* FIRST - The card has not been previously used in a transaction,\n  this is used as a hint to the networks that the card will be stored from\n  this point onward.\n* SUBSEQUENT - The card has been previously used in a transaction on your systems,\n  this lets the networks know that this is a previously stored card.\n\n*Usage Notes:*\n\n* Not sending a value for this implies that you have not stored the card for reuse\n  within your systems.\n* If your company never stores cards for reuse then there is no need to ever send\n  a value for this field.\n* This field is optional but *MUST* be filled when using a previously/externally stored card.\n",
            "enum": [
              "FIRST",
              "SUBSEQUENT"
            ]
          }
        }
      },
      "CheckoutRiskJs": {
        "description": "Risk instrument for Checkout's Risk.js product. Checkout's risk engine will also use the customer's IP address if available which can be provided via Payment.customerIpAddress\n",
        "type": "object",
        "required": [
          "deviceSessionId"
        ],
        "properties": {
          "deviceSessionId": {
            "type": "string",
            "description": "device_session_id token generated in Checkout's Risk.js package"
          }
        }
      },
      "GooglePay": {
        "title": "Google Pay",
        "description": "A type of [Payment Instrument].\n\nFor more information please refer to the [Google Pay Feature] page.\n\n[Payment Instrument]: https://docs.br-dge.io/docs/introduction#payment-instrument\n[Google Pay Feature]: https://docs.br-dge.io/docs/features-google-pay\n",
        "type": "object",
        "required": [
          "nonce",
          "type"
        ],
        "properties": {
          "type": {
            "type": "string",
            "description": "Discriminator field. Please see the discriminator mapping for the `PaymentInstrument` schema."
          },
          "nonce": {
            "$ref": "#/components/schemas/GooglePayToken"
          }
        }
      },
      "Kount": {
        "description": "Risk instrument for Kount risk engine\n",
        "type": "object",
        "required": [
          "sessionId"
        ],
        "properties": {
          "sessionId": {
            "type": "string",
            "description": "[Session ID] used in Kount's [Device Data Collector]\n\n[Session ID]: https://developer.kount.com/hc/en-us/sections/5319287642260-Integration-Guide?article=4411121644820\n[Device Data Collector]: https://developer.kount.com/hc/en-us/sections/5319287642260-Integration-Guide?article=4411121101844\n"
          }
        }
      },
      "Merchant": {
        "description": "Risk instrument for Merchant risk engine\n",
        "type": "object",
        "additionalProperties": {
          "type": "string",
          "minLength": 1,
          "maxLength": 200,
          "nullable": false,
          "maxProperties": 25,
          "description": "A map that contains key/value pairs representing data needed to call the Merchant risk engine\n\nUp to 25 fields can be included with the following constraints:\n\nThe field name may not be empty or have leading or trailing whitespace, and can consist of upper and lowercase letters, numbers, space, underscore \"_\", hyphen \"-\" and single quote \"'\".\n\nMaximum string length of field name and of field value is 200 chars.\n\nFor more information contact [Customer Support]\n\n[Customer Support]: https://docs.br-dge.io/docs/support#contact-support\n"
        }
      },
      "MerchantInitiatedDetails": {
        "title": "Merchant Initiated Details",
        "description": "If the transaction is the first payment within a series of merchant initiated transactions then `initialPayment` should be set to `true` and `previousPaymentId` should be omitted. The paymentId that is returned can then be used to make subsequent transactions, which are not cardholder initiated.\n\nWhen performing a payment that is a subsequent payment, then `initialPayment` should be set to `false` or ommited, and `previousPaymentId` should be set to the returned `paymentId` of the initial payment.\n\nThis field should be used in conjunction with the `merchantInitiated` field.\n",
        "properties": {
          "initialPayment": {
            "type": "boolean",
            "default": false,
            "description": "`true` If this is the first transaction within a series of MIT transactions (a CIT transaction)\n"
          },
          "previousPaymentId": {
            "type": "string",
            "description": "When the transaction is a subsequent payment, `previousPaymentId` should be set to the `paymentId` returned in the initial payment.\nIf `initialPayment` is set to `true`, then this field *must* be omitted.\n"
          }
        }
      },
      "PaymentInstrument": {
        "oneOf": [
          {
            "$ref": "#/components/schemas/ApplePay"
          },
          {
            "$ref": "#/components/schemas/AstroPay"
          },
          {
            "$ref": "#/components/schemas/Bancontact"
          },
          {
            "$ref": "#/components/schemas/Bank2BankPayment"
          },
          {
            "$ref": "#/components/schemas/BluVoucher"
          },
          {
            "$ref": "#/components/schemas/Card"
          },
          {
            "$ref": "#/components/schemas/ClickToPay"
          },
          {
            "$ref": "#/components/schemas/EasyPayPayment"
          },
          {
            "$ref": "#/components/schemas/EPayPayment"
          },
          {
            "$ref": "#/components/schemas/GooglePay"
          },
          {
            "$ref": "#/components/schemas/Ideal"
          },
          {
            "$ref": "#/components/schemas/NetellerPayment"
          },
          {
            "$ref": "#/components/schemas/OneVoucher"
          },
          {
            "$ref": "#/components/schemas/OttVoucher"
          },
          {
            "$ref": "#/components/schemas/PayPal"
          },
          {
            "$ref": "#/components/schemas/PaysafecardPayment"
          },
          {
            "$ref": "#/components/schemas/Pix"
          },
          {
            "$ref": "#/components/schemas/ProviderThreeDSecureNonce"
          },
          {
            "$ref": "#/components/schemas/PspTokenInstrument"
          },
          {
            "$ref": "#/components/schemas/RevolutPayPayment"
          },
          {
            "$ref": "#/components/schemas/Tokenized"
          },
          {
            "$ref": "#/components/schemas/TrustlyPayment"
          },
          {
            "$ref": "#/components/schemas/SkrillPayment"
          },
          {
            "$ref": "#/components/schemas/SkrillOneTapPayment"
          },
          {
            "$ref": "#/components/schemas/TrueLayerPayment"
          }
        ],
        "discriminator": {
          "propertyName": "type",
          "mapping": {
            "applePay": "#/components/schemas/ApplePay",
            "astroPay": "#/components/schemas/AstroPay",
            "bancontact": "#/components/schemas/Bancontact",
            "bank2bank": "#/components/schemas/Bank2BankPayment",
            "bluVoucher": "#/components/schemas/BluVoucher",
            "card": "#/components/schemas/Card",
            "clickToPay": "#/components/schemas/ClickToPay",
            "easyPay": "#/components/schemas/EasyPayPayment",
            "ePay": "#/components/schemas/EPayPayment",
            "googlePay": "#/components/schemas/GooglePay",
            "ideal": "#/components/schemas/Ideal",
            "neteller": "#/components/schemas/NetellerPayment",
            "oneVoucher": "#/components/schemas/OneVoucher",
            "ottVoucher": "#/components/schemas/OttVoucher",
            "payPal": "#/components/schemas/PayPal",
            "paysafecard": "#/components/schemas/PaysafecardPayment",
            "pix": "#/components/schemas/Pix",
            "providerThreeDSecureNonce": "#/components/schemas/ProviderThreeDSecureNonce",
            "pspToken": "#/components/schemas/PspTokenInstrument",
            "revolutPay": "#/components/schemas/RevolutPayPayment",
            "skrill": "#/components/schemas/SkrillPayment",
            "skrillOneTapPayment": "#/components/schemas/SkrillOneTapPayment",
            "tokenized": "#/components/schemas/Tokenized",
            "trueLayer": "#/components/schemas/TrueLayerPayment",
            "trustly": "#/components/schemas/TrustlyPayment"
          }
        }
      },
      "Action": {
        "title": "Action",
        "description": "An object that contains information required to perform an action after the response is received",
        "type": "object",
        "properties": {
          "type": {
            "type": "string",
            "description": "Value indicating the type of this post-response action.",
            "example": "3D_SECURE"
          },
          "paymentId": {
            "type": "string",
            "description": "The ID of the payment that this post-response action relates to.",
            "example": "57f7f444-29ce-4230-8c7f-1c1fd85c8bc9"
          },
          "data": {
            "type": "object",
            "additionalProperties": {
              "type": "string"
            },
            "description": "A map that contains key/value pairs representing data needed to process this post-response action.\n"
          }
        }
      },
      "ApplePay": {
        "title": "Apple Pay",
        "description": "A type of [Payment Instrument]. Apple Pay is a digital Wallet that offers your customers a simple, secure, and private way to pay within your iOS and watchOS apps, and on your websites via Safari. For more information please refer to the BR-DGE [Apple Pay feature guide].\n\n[Payment Instrument]: https://docs.br-dge.io/docs/introduction#payment-instrument\n[Apple Pay feature guide]: https://docs.br-dge.io/docs/features-apple-pay\n",
        "type": "object",
        "required": [
          "nonce",
          "type"
        ],
        "properties": {
          "type": {
            "type": "string",
            "description": "Discriminator field. Please see the discriminator mapping for the `PaymentInstrument` schema."
          },
          "nonce": {
            "$ref": "#/components/schemas/ApplePayToken"
          }
        }
      },
      "ApplePayToken": {
        "description": "If you are directly integrating with Apple Pay APIs on your client app then please refer to our [Apple Pay REST API guide] for details on how to generate an Apple Pay token for BR-DGE Payments.\n\nAlternatively you can use the [BR-DGE Web SDK Apple Pay module] to directly generate Apple Pay tokens for BR-DGE Payments.\n\n[Apple Pay REST API guide]: https://docs.br-dge.io/docs/rest-api-apple-pay\n[BR-DGE Web SDK Apple Pay module]: https://docs.br-dge.io/docs/apple-pay-module\n",
        "type": "string",
        "minLength": 0,
        "example": "BR#00000000-0000-0000-0000-000000000000"
      },
      "AstroPay": {
        "title": "AstroPay",
        "description": "A type of [Payment Instrument].\n\nPlease note: `documentId`, `documentType`, `customerFirstName`, and `customerLastName` are also required for AstroPay payments if you are a merchant operating in the Gaming industry in Brazil. In this case 'CPF' is the only accepted document type. If you are unsure whether you need to supply this data, please raise a ticket with support on the BR-DGE Support Portal at <https://docs.br-dge.io/docs/support#contact-support>.\n\n[Payment Instrument]: https://docs.br-dge.io/docs/introduction#payment-instrument\n",
        "type": "object",
        "required": [
          "type",
          "redirectUrl",
          "productCode",
          "productDescription"
        ],
        "properties": {
          "type": {
            "type": "string",
            "description": "Discriminator field. Please see the discriminator mapping for the `PaymentInstrument` schema."
          },
          "redirectUrl": {
            "type": "string",
            "maxLength": 300,
            "example": "https://myurl.com/f219ea52-d91f-4059-a560-8dd7cbd31fd0",
            "description": "URL that your customer's browser will be redirected to after completing the transaction.\n\nBy using unpredictable single-use URLs you can protect yourself from the possibility of bad actors attempting to make it appear that payments had a different outcome to reality. We also recommend that you confirm the outcome of payments via server-to-server calls to BR-DGE.\n"
          },
          "userId": {
            "type": "string",
            "maxLength": 64,
            "description": "The customer's AstroPay User ID. If it's included in the request only that user will be able to complete the payment. The User ID is only assigned after a successful request, where it can then be found when confirming the outcome of the payment via our [Payment Status endpoint] or via BR-DGE callback.\n\n[Payment Status endpoint]: https://docs.br-dge.io/reference/getpaymentstatususingget\n",
            "example": "Vx0H4pdAtPCz"
          },
          "productCode": {
            "type": "string",
            "maxLength": 32,
            "description": "Merchant's unique identifier for the product being purchased.\n",
            "example": "123456"
          },
          "productDescription": {
            "type": "string",
            "maxLength": 128,
            "description": "Description of the product being purchased.\n",
            "example": "My product description"
          }
        }
      },
      "Bancontact": {
        "title": "Bancontact",
        "description": "A type of [Payment Instrument].\n\nPlease note: `currencyCode` must be `EUR` and `billingAddress.country` must be `BE`.\n\n[Payment Instrument]: https://docs.br-dge.io/docs/introduction#payment-instrument\n",
        "type": "object",
        "required": [
          "type"
        ],
        "properties": {
          "type": {
            "type": "string",
            "description": "Discriminator field. Please see the discriminator mapping for the `PaymentInstrument` schema."
          },
          "successUrl": {
            "type": "string",
            "maxLength": 300,
            "minLength": 2,
            "description": "A url that is invoked after a successful Bancontact payment.",
            "example": "https://myurl.com/success"
          },
          "errorUrl": {
            "type": "string",
            "maxLength": 300,
            "minLength": 2,
            "description": "A url that is invoked after an unsuccessful Bancontact payment.",
            "example": "https://myurl.com/error"
          }
        }
      },
      "ClickToPay": {
        "title": "Click-to-Pay",
        "type": "object",
        "description": "A type of [Payment Instrument]. Click-to-Pay, also called Unified Click-to-Pay or Unified Checkout, is a multi-network digital wallet solution provided by VISA Acceptance.\n[Payment Instrument]: https://docs.br-dge.io/docs/introduction#payment-instrument\n",
        "required": [
          "nonce",
          "type"
        ],
        "properties": {
          "type": {
            "type": "string",
            "description": "Discriminator field. Please see the discriminator mapping for the `PaymentInstrument` schema.",
            "example": "clickToPay"
          },
          "nonce": {
            "$ref": "#/components/schemas/ClickToPayToken"
          }
        }
      },
      "ClickToPayToken": {
        "description": "Upon calling the Click-to-Pay's `checkout()` method, a JSON Web Token (JWT) is returned. Decoding this provides a secondary `uctpResponse.payload` JWT value.\nThis `payload` should be provided to BR-DGE via the `/v1/payment-instruments/single-use` endpoint, with the resulting BR-DGE single-use token provided to this field.\n",
        "type": "string",
        "minLength": 0,
        "example": "94ec2d98-d2c9-422c-95e2-b6c4c8400968",
        "pattern": "^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$"
      },
      "GooglePayToken": {
        "description": "## If you integrate directly with the Google Pay&trade; API\nFollow the procedure in the Google Pay documentation to integrate your [web](https://developers.google.com/pay/api/web/guides/setup) or [Android](https://developers.google.com/pay/api/android/guides/setup) application.\nIn the step where you choose a payment tokenization method, choose `Gateway`, then set `comcarde` as your `gateway`. If you have not been provided with a `gatewayMerchantId` parameter, please raise a ticket with support on the BR-DGE Support Portal at <https://docs.br-dge.io/docs/support#contact-support>.\n## If you use a BR-DGE SDK\nThe BR-DGE SDK can optionally be used to automate client side interactions with the Google Pay&trade; API. The SDK will output a nonce that you can directly use.\nFor more information please refer to the [Google Pay Feature](https://docs.br-dge.io/docs/features-google-pay) page.\n",
        "type": "string",
        "minLength": 0,
        "example": "{\"apiVersion\":2,\"apiVersionMinor\":0, \"paymentMethodData\":{\"description\": \"Test Card: Visa •••• 1111\", \"info\":{\"assuranceDetails\":{\"accountVerified\":true, \"cardHolderAuthenticated\":false},\"cardDetails\":\"1111\", \"cardNetwork\":\"VISA\"},\"tokenizationData\":{\"token\": \"{\"signature\":\"MEUCIBSc1HRfQds/JkpNXakkaJf2geKR9HZE4Rhof/ qnNRymAiEArDzEmaOC+lTqzHmvA+Z1sFfRMROdtr0pTAGVFWUjLV4u003d\", \"intermediateSigningKey\":{\"signedKey\":\"{\"keyValue\": \"MFkwEwYHKoZIzj0CAQYIKoZIzj0DAQcDQgAE60Dnzr+/JD +xJOOIFBMRyVoqPCbQcBjj/TwGJu9ct/srT8tZDDWJzNZo2vDE50YLE38oHBJWLjAws hqDzKfQKQu003du003d\",\"keyExpiration \":\"1710831722061\"}\",\"signatures\":[\"M EUCIQDqib3bqGDAzyQRRtc7xci1EzhNqxAj1oEIrCfSiUd7WAIgc09CIVz7zKa9StsZ Bw95vvoRORsbF1qCKtPk5ltQihEu003d\"]},\"protocolVersion\": \"ECv2\",\"signedMessage\":\"{\"encryptedMessage \":\"My/Y7NLgWNCMiQzd/muw8XyCMDhMS38j9FjTyKPsmKNWM5UHl+PkT urYyVv6kSJGAkWF6HCBIx3J1Ch6kJtx4w8/pmP7ujxCwEiDiynsffAIeubQpkv69gIp +H/SZs7DiqOvdhXhHF5vpkYvU3NmVMjvNZeU3rgclwldC1IAJzGyxdafLYu7WKtajEv bBfIq/Rp+XXGkTw4pkGt7MYVNcWqUY4qO1mRmIyyj+UrR5wru9rXlxZu9xA0ofdBc4a 8tkOp6wUgD+5+VMZ3GbUrQZbV+hnwFqMl60U1+u2nSr9PInbusVT73tqr2Y37EmViCC I1s0Evoj8nakWgblLQ9L0HMS2G9XdIvktuLS2oDDxZziv1IquBShyYeik0Hhceq5HK9 d16MTIpLm1kP188YL1TtHoVCRNJX0T5lTfsTATN9PsMp9fl+SRBzjr2ZrfFtyjJB652 wi6FMJquIcVIoc1t6HAJ6ZQQyaR8gWaV+/BmkIm6EPmOUczF5sYTNGXilnKf91PwaoN zhBnatlx468fqkvyKGN5pjfsK2BCUGJJw9UwiYPWNrD24fzJ/Fwlxh0uToo5CiT8KmA qoKSxzJ9Fh/XtVsbbH0+yfUBNUfLsWs3Rsu003d\",\"eph emeralPublicKey\":\"BLyIO17wMMcKccD9XJMlUQ8vHnI3IfoE6Ss bQuVxerTtolZ7ICGRhW0lbxF3q7blzvgSDIYLk9cab27mCKT0sy0u003d \",\"tag\":\"CIKT0sRruAuW7nJ3THAgZuWHpE0PJBc4 eLmfHRWZgpsu003d\"}\"}\", \"type\":\"PAYMENT_GATEWAY\"},\"type\":\"CARD\"}}"
      },
      "Ideal": {
        "title": "iDEAL",
        "description": "A type of [Payment Instrument].\n\nPlease note: `currencyCode` must be `EUR` and `billingAddress.country` must be `NL`.\n\n[Payment Instrument]: https://docs.br-dge.io/docs/introduction#payment-instrument\n",
        "type": "object",
        "required": [
          "type"
        ],
        "properties": {
          "type": {
            "type": "string",
            "description": "Discriminator field. Please see the discriminator mapping for the `PaymentInstrument` schema."
          },
          "successUrl": {
            "type": "string",
            "maxLength": 300,
            "minLength": 2,
            "example": "https://myurl.com/success/f219ea52-d91f-4059-a560-8dd7cbd31fd0",
            "description": "URL that your customer's browser will be redirected to after they successfully authorize a payment via iDEAL.\n\nBy using unpredictable single-use URLs you can protect yourself from the possibility of bad actors attempting to make it appear that payments had a different outcome to reality. We also recommend that you confirm the outcome of payments via server-to-server calls to BR-DGE.\n"
          },
          "errorUrl": {
            "type": "string",
            "maxLength": 300,
            "minLength": 2,
            "description": "A url that is invoked after an unsuccessful iDEAL payment.",
            "example": "https://myurl.com/error"
          }
        }
      },
      "NetellerPayment": {
        "title": "Neteller",
        "description": "A type of [Payment Instrument](https://docs.br-dge.io/docs/introduction#payment-instrument).\nPlease see [Paysafe](https://docs.br-dge.io/docs/paysafe-integration) for more information on this integration.\n",
        "type": "object",
        "required": [
          "type",
          "defaultUrl"
        ],
        "properties": {
          "type": {
            "type": "string",
            "description": "Discriminator field. Please see the discriminator mapping for the `PaymentInstrument` schema."
          },
          "defaultUrl": {
            "type": "string",
            "format": "uri",
            "description": "The default URL that a customer is redirected to after user interaction with Neteller.",
            "example": "https://myurl.com/default"
          },
          "failedUrl": {
            "type": "string",
            "format": "uri",
            "description": "A URL that a customer is redirected to if the authorization on Neteller fails.",
            "example": "https://myurl.com/failed"
          },
          "cancelledUrl": {
            "type": "string",
            "format": "uri",
            "description": "A URL that a customer is redirected to if the Neteller request is cancelled.",
            "example": "https://myurl.com/cancelled"
          }
        }
      },
      "OneVoucher": {
        "title": "1Voucher",
        "description": "A type of [Payment Instrument]\n\nPlease note: `currencyCode` must be `ZAR` and `amount` must be `0`.\n\n[Payment Instrument]: https://docs.br-dge.io/docs/introduction#payment-instrument\n",
        "type": "object",
        "required": [
          "pin",
          "type"
        ],
        "properties": {
          "type": {
            "type": "string",
            "description": "Discriminator field. Please see the discriminator mapping for the `PaymentInstrument` schema."
          },
          "pin": {
            "type": "string",
            "description": "The 16 digit PIN from the Voucher",
            "maxLength": 16,
            "minLength": 16,
            "pattern": "^[0-9]*$",
            "example": "1234567890123456"
          }
        }
      },
      "OttVoucher": {
        "title": "OTT Voucher",
        "description": "A type of [Payment Instrument]\n\nPlease note: `currencyCode` must be `ZAR`.\n\n[Payment Instrument]: https://docs.br-dge.io/docs/introduction#payment-instrument\n",
        "type": "object",
        "required": [
          "type",
          "pin",
          "mobile"
        ],
        "properties": {
          "type": {
            "type": "string",
            "description": "Discriminator field. Please see the discriminator mapping for the `PaymentInstrument` schema."
          },
          "pin": {
            "type": "string",
            "description": "The voucher PIN",
            "maxLength": 25,
            "pattern": "^[0-9]*$",
            "example": "720686941917"
          },
          "mobile": {
            "$ref": "#/components/schemas/PhoneNumber"
          }
        }
      },
      "BluVoucher": {
        "description": "A type of [Payment Instrument]\n\nPlease note: `currencyCode` must be `ZAR`.\n\n[Payment Instrument]: https://docs.br-dge.io/docs/introduction#payment-instrument\n",
        "type": "object",
        "required": [
          "type",
          "pin"
        ],
        "properties": {
          "type": {
            "type": "string",
            "description": "Discriminator field. Please see the discriminator mapping for the `PaymentInstrument` schema."
          },
          "pin": {
            "type": "string",
            "description": "The voucher PIN",
            "minLength": 9,
            "maxLength": 16,
            "pattern": "^[0-9]+$",
            "example": "720686941917"
          }
        }
      },
      "PayPal": {
        "title": "PayPal",
        "description": "A type of [Payment Instrument]\n\n[Payment Instrument]: https://docs.br-dge.io/docs/introduction#payment-instrument\n",
        "type": "object",
        "required": [
          "nonce",
          "type"
        ],
        "properties": {
          "type": {
            "type": "string",
            "description": "Discriminator field. Please see the discriminator mapping for the `PaymentInstrument` schema."
          },
          "nonce": {
            "maxLength": 255,
            "minLength": 1,
            "type": "string",
            "description": "Nonce value that represents the details of the PayPal payment.",
            "example": "BR#00000000-0000-0000-0000-000000000000"
          }
        }
      },
      "PaysafecardPayment": {
        "title": "Paysafecard",
        "description": "A type of [Payment Instrument](https://docs.br-dge.io/docs/introduction#payment-instrument).\nPlease see [Paysafecard](https://docs.br-dge.io/docs/paysafecard-integration) for more information on this integration.\n",
        "type": "object",
        "required": [
          "type",
          "successUrl",
          "errorUrl"
        ],
        "properties": {
          "type": {
            "type": "string",
            "description": "Discriminator field. Please see the discriminator mapping for the `PaymentInstrument` schema."
          },
          "successUrl": {
            "type": "string",
            "description": "A url that a customer is redirected to after successful or failed authorization on Paysafecard.",
            "example": "https://myurl.com/success"
          },
          "errorUrl": {
            "type": "string",
            "description": "A url that a customer is redirected to after customer cancels the payment on Paysafecard",
            "example": "https://myurl.com/error"
          },
          "countryRestriction": {
            "type": "string",
            "pattern": "^[A-Za-z]{2}$",
            "description": "ISO 3166-1 alpha-2 two-letter country code used to restrict payments to residents of a particular country.",
            "example": "GB"
          },
          "kycLevel": {
            "type": "string",
            "description": "The Know Your Customer (KYC) level of the customer's myPaysafe account. Depending on the country, myPaysafe accounts are offered with SIMPLE and/or FULL customer identification.\n",
            "enum": [
              "SIMPLE",
              "FULL"
            ]
          },
          "minAge": {
            "type": "integer",
            "description": "Restricts payments to myPaysafe customers only, who are equal to or older than the specified age. Please note, this means that it is required that the customer has a registered myPaysafe account to make the payment.\n",
            "example": 18
          },
          "submerchantId": {
            "type": "string",
            "maxLength": 8,
            "description": "ID used to classify sub-merchants. Values must be agreed with Paysafecard, non-agreed values will lead to a failed payment.\n"
          }
        }
      },
      "Pix": {
        "title": "Pix",
        "description": "A type of [Payment Instrument](https://docs.br-dge.io/docs/introduction#payment-instrument).\nPix is an instant payment system created and managed by the Central Bank of Brazil.\n",
        "type": "object",
        "required": [
          "type"
        ],
        "properties": {
          "type": {
            "type": "string",
            "description": "Discriminator field. Please see the discriminator mapping for the `PaymentInstrument` schema."
          },
          "successUrl": {
            "type": "string",
            "maxLength": 300,
            "minLength": 2,
            "example": "https://myurl.com/success/f219ea52-d91f-4059-a560-8dd7cbd31fd0",
            "description": "A URL that is invoked after a successful Pix payment.\nBy using unpredictable single-use URLs you can protect yourself from the possibility of bad actors attempting to make it appear that payments had a different outcome to reality. We also recommend that you confirm the outcome of payments via server-to-server calls to BR-DGE.\n"
          },
          "errorUrl": {
            "type": "string",
            "maxLength": 300,
            "minLength": 2,
            "description": "A URL that is invoked after an unsuccessful Pix payment.",
            "example": "https://myurl.com/error"
          }
        }
      },
      "ProviderThreeDSecureNonce": {
        "description": "A type of [Payment Instrument].\nPart of the [3-D Secure Payment Flow]. In the event that you get a 3-D Secure additional action required response to a payment request, you can use the [BR-DGE Web SDK Post Response Module] to handle the action and convert it into a nonce you can use to complete the payment with a `ProviderThreeDSecureNonce` [Payment Instrument].\n\n[BR-DGE Web SDK Post Response Module]: https://docs.br-dge.io/docs/post-response-module\n[Payment Instrument]: https://docs.br-dge.io/docs/introduction#payment-instrument\n[3-D Secure Payment Flow]: https://docs.br-dge.io/docs/payment-flows#3-d-secure-payment-flow\n",
        "type": "object",
        "required": [
          "nonce",
          "paymentId",
          "type"
        ],
        "properties": {
          "type": {
            "type": "string",
            "description": "Discriminator field. Please see the discriminator mapping for the `PaymentInstrument` schema."
          },
          "paymentId": {
            "type": "string",
            "pattern": "^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$",
            "description": "Payment ID of the payment",
            "example": "00000000-0000-0000-0000-000000000000"
          },
          "nonce": {
            "maxLength": 255,
            "minLength": 0,
            "type": "string",
            "pattern": "^([A-Z0-9_]{2,25})(#)([a-zA-Z0-9\\-'.]+)$",
            "description": "Nonce value that represents the details of the payment along with its 3-D Secure authentication outcome",
            "example": "BR#00000000-0000-0000-0000-000000000000"
          }
        }
      },
      "TrustlyAccountId": {
        "type": "string",
        "description": "This is Trustly's bank account identifier, used to enable [Trustly Express flow] transactions. Providing the `accountId` streamlines transactions for returning customers, allowing them to bypass steps and complete transactions faster, which enhances customer loyalty and increases conversion rates.\n\nThe `accountId` can be obtained from:\n- Payment Instrument Account Selection BR-DGE callback\n- `GET /v1/payments` response\n- `GET /v1/payments/{paymentId}/status` response\nNote: Ensure the `customerId` matches the customer ID from the previous transaction associated with this `accountId`.\n\n[Trustly Express flow]: https://eu.developers.trustly.com/doc/reference/trustly-express-overview\n",
        "maxLength": 100,
        "example": "1234567890"
      },
      "TrustlyBase": {
        "type": "object",
        "title": "Trustly",
        "required": [
          "type",
          "successUrl",
          "errorUrl"
        ],
        "description": "Trustly is an Open Banking [Payment Instrument].\n\nWhen using this instrument type for a payment, you must provide a customer ID in the `payment.customerId` field. This field is used within Trustly back office to help merchants keep track of the transaction.\n\nFor more information, please see our [Trustly User Guide].\n\n[Trustly User Guide]: https://docs.br-dge.io/docs/trustly#/\n[Payment Instrument]: https://docs.br-dge.io/docs/introduction#payment-instrument\n",
        "properties": {
          "type": {
            "type": "string",
            "description": "Discriminator field. Please see the discriminator mapping for the `PaymentInstrument` schema."
          },
          "successUrl": {
            "type": "string",
            "minLength": 2,
            "maxLength": 300,
            "example": "https://myurl.com/success/f219ea52-d91f-4059-a560-8dd7cbd31fd0",
[...]
